'FFSubmenu=Dokumentation
'FFName=Bilddaten nach Word/Excel

'FFSkriptName=\Bilddaten.vbs
'FFSkriptArchiv=\Bilddaten.zip
'FFSkriptDirectory=\MeckiScript\Bilddaten
'FFSkriptFiles=\MeckiScript\Bilddaten\Bilddaten.ini
'FFScriptProfile=FF_Bilddaten

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=2.00
'FFSkriptURL=https://www.meckis-steckenpferde.de/Download/FF_Skripte/Bilddaten.zip
'FFVersionMin=2.90.0

' ********************************************************************
' Bilddaten.vbs (Skript fr FixFoto)
' Funktion:	Bilder mit auswhlbaren Bilddaten in ein Word-Dokument bertragen
'
' Copyright Harald Maeckler, Dsseldorf 2013 - 2021
'
'** Start Kurzbeschreibung *******************************************
' Bilddaten nach Word/Excel / Version 2.00
' =========================
' Voraussetzung zur Anwendung ist eine installierte Word- und Excel-Software von
' Microsoft, mindestens Version 2000.
'
' Worddatei
' ------------
' Mit dem Befehl "Worddatei" werden nacheinander die ausgewhlte Bilder in ein 
' Word-Dokument bertragen. Dabei werden jeweils ein oder mehrere Bilder neben-
' einander dargestellt und darunter die vom Benutzer bestimmten Bilddaten aufge-
' listet.
'
' Exceltabelle
' --------------
' Mit dem Befehl "Exceltabelle" werden die Daten der ausgewhlten Bilder in
' eine Exceldatei bertragen. In der ersten Spalte kann man sich eine Popup-
' Darstellung des jeweiligen Bildes anzeigen lassen, indem man den Mauscursor
' darber stellt, alternativ das Bild in einer vergrerten Zelle.
'
' Datenauswahl und bertragungsvorgang
' -------------------------------------------------
' Die zu zeigenden Bilddaten und deren Reihenfolge werden in einer Initialisierungs-
' Datei festgelegt. ber den Befehl "Editieren" wird diese Datei aufgerufen und kann
' nach den in der Datei nachzulesenden Regeln angepasst werden. Nach einer n-
' derung muss man diese unbedingt abspeichern und den Editor wieder schlieen.
' Nheres dazu kann weiter unten unter Initialisierungsdatei nachgelesen werden.
'
' Mit "Exceltabelle" bzw. "Worddatei" beginnt die bertragung. Der Fortschritt wird
' mit einem grnen Balken angezeigt.
' Die fortlaufende bertragung in ein Worddokument kann jederzeit durch Bettigung
' der Taste "Backspace" unterbrochen werden. Nach Anzeige der Anzahl bereits ber-
' tragener Bilder kann man entscheiden, ob die bertragung endgltig abgebrochen 
' oder fortgesetzt wird.
'
' Auswahl
' ----------
' Hier wird festgelegt welche Bilder mit ihren Bilddaten in ein neues Word-Dokument 
' bertragen werden sollen.
'
'
' Die folgenden Einstellungen gelten nur fr die bertragung nach Word
' ==========================================
'
' Word-Vorlage
' -----------------
' Whlt man 'Standard-Vorlage' wird einfach ein neues Dokument angelegt. Man kann
' aber auch die mitgelieferte Vorlage 'Bilddaten.dot' oder eine beliebige, selbst 
' erstellte Vorlage verwenden. Mit "..." ruft man einen Dateiexplorer auf und whlt
' die gewnschte Vorlage aus.
' ber die Vorlage kann auch die Breite der Seitenrnder bestimmt werden.
'
' Schrift
' --------
' Hier wird bestimmt welche Schriftart in welcher Gre fr die Bilddaten verwendet
' wird. Desto mehr Bilder pro Zeile desto kleiner sollte die Schrift sein.
'
' Bildparameter
' ----------------
' - Punktdichte
' Zum Ausdruck wird eine Punktdichte von mindestens 200 dpi empfohlen.
' - Qualitt
' Mit dem Wert 0 wird festgelegt, dass die Qualittseinstellung in FixFoto bernommen
' wird. Es sind aber auch andere Werte zwischen 60 und 100 % mglich. In der Regel
' ist ein Wert von 80 % ausreichend.
' - Bildlage vertikal und Bildlage horizontal
' Es kann zwischen 'Oben', 'Mitte' und 'Unten' bzw. 'Links', Mitte' und 'Rechts' gewhlt
' werden. Bedeutung haben diese Auswahlen immer dann, wenn nebeneinander ein 
' quer- und ein hochformatiges Bild abgebildet wird.
'
' Layout
' --------
' - Anzahl Bilder pro Zeile
' Man kann 1 bis 6 Bilder pro Zeile whlen. Natrlich mssen Schriftgre, Tabulator-
' weite und ggf. die Seitenrnder in der verwendeten Vorlage angepasst werden.
' - Tabulatorweite
' Bei den Bilddaten erfolgt erst die Benennung, dann nach einem Tabstopp der Wert.
' Der Standardwert fr die Tabulatorweite betrgt 35 mm. Dieser Wert muss je nach
' Schriftart und Schriftgre angepasst werden.
' - Seitenwechsel
' Es kann festgelegt werden, dass nach einer bestimmten Anzahl von Bildpaaren mit
' ihren Bilddaten ein Seitenwechsel erzwungen wird.
' - Leerwertanzeige unterdrcken
' Normalerweise werden auch ausgewhlte Bilddaten, die keinen Inhalt haben, angezeigt.
' Mit dieser Option knnen diese unterdrckt werden.
' ==========================================
'
' Initialisierungsdatei
' -----------------------
' - Profil
' In der Initialisierungsdatei knnen verschiedene, frei zu benennende Profile angelegt
' werden, die dann zur Auswahl zur Verfgung stehen. In den Profilen werden die nach
' Word zu bertragenden Daten und ihre Reihenfolge festgelegt. Auerdem knnen ihnen
' Einstellwerte fr die Schrift und das Layout zugeordnet werden. Die Regeln dafr 
' sind in der Initialisierungsdatei nachzulesen.
' - Editieren
' Mit diesem Befehl wird mit dem Standard-Texteditor die Initialisierungsdatei geffnet.
' Nach einer nderung muss diese unbedingt abgespeichert und der Editor wieder ge-
' schlossen werden. Nach dem Schlieen wird abgefragt, ob ein Backup der Datei erstellt
' werden soll.
' - Backup
' Es ist immer dann sinnvoll ein Backup der Initialisierungsdatei zu erstellen, wenn man
' dort eigene Einstellungen vorgenommen hat, die man nach einem Update des Skripts 
' zurck speichern will.
' - Restore
' Mit dem bestehenden Backup kann man die vorhandene Initialisierungsdatei berschreiben.
' Backup und Restore werden jeweils erst nach einer Sicherheitsabfrage ausgefhrt.
' - Speichern und Lschen
' Die Einstellwerte fr Schrift und Layout knnen nach einer Sicherheitsabfrage im aktu-
' ellen Profil gespeichert bzw. gelscht werden
'
' Tipp zur Anzeige langer Daten
' ------------------------------------
' Bei Daten, die lnger sind als der normalerweise zur Verfgung stehende Platz in einem
' Word-Dokument, wie z.B. beim "Dateipfad", kann es zu unliebsamen Umbrchen kommen. Hier
' wird empfohlen in der ini-Datei dafr zu sorgen, dass die ganze Spaltenbreite dafr zur
' Verfgung gestellt wird:
'
'	Dateipfad
'	  = h
'
'Das Ergebnis sieht dann beispielsweise so aus:
'
'	Dateipfad
'	  D:\Eigene Dateien\Eigene Bilder\2010_10 Zoo Duisburg
'
' Die zwei Leerzeichen vor der Kennungszuweisung sorgen fr eine Einrckung der Date.
'
' Reicht das immer noch nicht, wird empfohlen auf den Dateipfad in Kurzform mit der 
' Kennung i zurck zu greifen mit dem Ergebnis
'
'	Dateipfad
'	  D:\EIGENE~1\EIGENE~1\2010_1~2\BEARBE~1\Internet
'
' oder sich nur den Ordnernamen mit Kennung a anzeigen zu lassen:
'
'	Dateiordner	...\Internet
'
' Die zweizeilige Darstellung funktioniert allerdings nur bei der Erstellung von Word-
' dateien. Bei Exceltabellen wird die Spaltenberschrift immer aus dem Textteil vor dem
' Gleichheitszeichen in der selben Zeile gebildet.
'
' Codepage
' -------------
' Fr verschiedene Sprachrume kann ein sogenanntes Mapping aktiviert werden. Die Code-
' pagenorm kann in diesem Fall ausgewhlt werden.
' Wenn 'Auto' zu falschen Umlauten und Sonderzeichen fhrt, dann nacheinander die anderen
' Einstellungen testen.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Es wird berprft, ob das zugehrige zip-Archiv im 
' Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten, davon eine Sicher-
' heitskopie an einem beliebigen Speicherort abzulegen. Dann werden nacheinander die 
' Skriptdatei, die in der Registry dazu gehrenden Daten und eventuelle Zusatzdateien
' gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
'
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Die vorliegende Beschreibung ist als pdf-Datei im FF-Skriptordner und dort im Unterordner
' 'MeckiSkript\Bilddaten' zu finden, wo auch die ini-Datei abgelegt ist. Sie kann ber den
' Befehl '?' aufgerufen werden, vorausgesetzt es ist ein pdf-Reader installiert.
'
' Copyright Harald Maeckler
'
'** Ende Kurzbeschreibung ********************************************
'
' Version 2.00 vom 29.10.2021	- Bildanzeige in Exceltabelle (Spalte A) optional
' Version 1.34 vom 29.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 1.33 vom 24.11.2013	- Updatefunktion hinzugefgt
'								- Mapping aktivierbar / Codepagenorm frei whlbar
'								- Tooltipps hinzugefgt
'								- Kurzbeschreibung berarbeitet
' Version 1.32 vom 01.09.2011	- Bildfilter um JPEG erweitert
' Version 1.31 vom 01.09.2011	- "CountyCode" korrigiert -> "CountryCode"
' Version 1.30 vom 23.04.2011	- Exceltabelle mglich
' Version 1.20 vom 25.03.2011	- Bercksichtigung des Zeichensatz bei den IPTC-Daten
' Version 1.19 vom 08.01.2011	- Textkrper in Vorlage jetzt zulssig
' Version 1.18 vom 01.12.2010	- Bug bei fehlendem Bild beseitigt
' Version 1.17 vom 01.12.2010	- max. Anz. der Bilder pro Zeile auf 8 erhht
' Version 1.16 vom 01.12.2010	- Bug bei leerem Profil beseitigt
' Version 1.15 vom 26.11.2010	- Speichern und Lschen von Einstellwerten
'									in das aktuelle Profil
' Version 1.14 vom 19.11.2010	- nach Editieren ini-Datei neu einlesen
' Version 1.13 vom 17.11.2010	- Bug bei fehlenden Exif-Daten beseitigt
' Version 1.12 vom 17.11.2010	- Kurzbeschreibung berarbeitet
'								- Lndereinstellung "de-de" gesetzt
' Version 1.11 vom 16.11.2010	- Profileinstellung werden, falls vorhanden
'									in der Bedienoberflche angezeigt
' Version 1.10 vom 15.11.2010	- Kurzbeschreibung direkt als PDF aufrufbar
'								- Abschnitte heien jetzt Profile
'								- in den Profilen knnen bestimmte
'									Einstellungen festgelegt werden
' Version 1.09 vom 12.11.2010	- Abschnitte in der ini-Datei ermglicht
'								- Backup und Restore fr ini-Datei
' Version 1.08 vom 10.11.2010	- Bildfilter sortiert aus was keine 
'									Dateierweiterung JPG, JP2, PNG, TIF oder BMP hat
'								- mglichen Fehler beseitigt wenn natrlicher
'									 und erzwungener Seitenwechsel zusammen treffen
' Version 1.07 vom 09.11.2010	- Bildlage auch horizontal whlbar
' Version 1.06 vom 08.11.2010	- kleine Bugs beseitigt
'								- Bildnummerierung ber ini-Datei mglich
' Version 1.05 vom 07.11.2010	- Bilder pro Zeile von 1 bis 6 whlbar
' Version 1.04 vom 05.11.2010	- 'Kompletter Dateipfad' auswhlbar
' Version 1.03 vom 04.11.2010	- Wordzellen selektieren vereinfacht
' Version 1.02 vom 01.11.2010	- Kurzbeschreibung erstellt
' Version 1.01 vom 27.10.2010	- Datenauscodierung berarbeitet
' Version 1.00 vom 08.10.2010	- Betaversion
' ********************************************************************

'**Start Encode**

Option Explicit

'Geopage-Einstellung
Dim MappingAktiv
Dim CodeP_Wert,CodeP_Auswahl,CodePa_Array,CodePw_Array,CodePelement,MappMerker
Const CodePwerte   = "Auto/MacRoman/UTF-8/US-ASCII/ISO-8859-1/ISO8859-15"
Const CodePauswahl = "Auto/10000/65001/10127/28591/28605"

'Updatekonstanten und Variable
const SkriptVersion = "2.00"
const SkriptURL = "https://www.ffsf.de/resources/bilder-mit-bilddaten-nach-word-excel.139/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde

Dim SkriptName
const Skript = "Bilddaten"								'Skriptname
const RegSchluessel = "FF_Bilddaten"					'Registryschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch	'Kurzbeschreibung
const ForReading = 1, ForWriting = 2
Abbruch = false

Dim objFS,WshShell										'Objekte
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

Dim SkriptKill,Antwort,TempFile	 : SkriptKill = false	'Lschroutine

Dim Array,Auswahl,Bilder,n,img
Dim word,TBreitePx,BildLaenge,TempBild,AgSpalte,BspBreite
Dim WerteArray,WerteElement,ini_FileName,Codepage

'### Word-Konstanten
const wdWord9TableBehavior 		= 1
const wdAutoFitFixed 			= 0
const wdFieldEmpty 				= -1
const wdAdjustNone 				= 0
const wdHorizontalPositionRelativeToPage = 5
const wdHorizontalPositionRelativeToTextBoundary = 7
const wdPageBreak 				= 7

const wdAlignParagraphLeft		= 0
const wdAlignParagraphCenter	= 1
const wdAlignParagraphRight		= 2

const wdCellAlignVerticalTop 	= 0
const wdCellAlignVerticalCenter = 1
const wdCellAlignVerticalBottom = 3
'###

'Bedienoberflche
Dim bool_StdVorlage,bool_Vorlage,p_Vorlage,Vorlagenname,Pfadvorschlag,Eingabe

Dim p_Schrift,p_SGroesse
Dim p_Dichte,p_Qualitaet,p_BVertikal,BildVertikal,p_BHorizontal,BildHorizontal
const Dichte = "72/100/150/200/300/400"
const Vertikal = "Oben/Mitte/Unten"
const Horizontal = "Links/Mitte/Rechts"
Dim AnzBilder,p_TabMM,Tabulator,bool_SWechsel,p_SWechsel,bool_LWAno,Anzeige
const AnzMax = 8
const Bildfilter = ".JPG.JP2.PNG.TIF.BMP.JPEG."

'### Excel
Dim excel
Set excel = CreateObject("Excel.Application")
Dim ExcelT	'wenn true, wird eine Exceltabelle ausgegeben
Dim EArrayU	'berschriften
Dim EArrayG	'Gesamtdaten
Dim EArrayE	'Einzelbilddaten
const Thumbnail = true	'wenn true -> 1. Spalte Thumbnaileintrge
const BildAnz   = true	'wenn true -> 1. Spalte Bildanzeige statt Thumbnail
'--------------------------------------------------------------------------
'Bilddaten

Dim Tags,Tags_Array
Tags =  "MeteringMode#YResolution#XResolution#Satellites#ExposureIndex#ExposureBiasValue#ExposureProgram#ExposureTime#ImageDescription#Orientation#" & _
		"FNumber#ApertureValue#Flash#Latitude#FocalLength#FocalLengthIn35mmFilm#DateTimeDigitized#ResolutionUnit#SubjectDistance#Artist#" & _
		"BrightnessValue#Make#Altitude#MapDatum#UserComment#Longitude#LightSource#MaxApertureValue#Model#Copyright1#" & _
		"Copyright2#ISOSpeedRatings#Software#ShutterSpeedValue#WhiteBalance#DateTimeOriginal#DateTime#TimeStamp#WhiteBalance#ExposureTime#" & _
		"LightSource#FNumber#FocalLength#OriginalTransmissionReference#Byline#EditStatus#SpecialInstructions#CopyrightNotice#Urgency#DateCreated#" & _
		"TimeCreated#Writer/Editor#Category#Country#CountryCode#ObjectAttributeRef#Caption/Abstract#ObjectName#City#Source#" & _
		"Credit#SubjectRef#Keywords#ProvinceState#BylineTitle#Headline#SupplementalCategory#Characterset#Sublocation"
Tags_Array = split(Tags,"#")

Dim Messmethode,Messmethode_Array					'Kennung =  0 / max. 7 Werte
Messmethode = 			"unbekannt/Integral/Mittenbetont/Spot/MultiSpot/Mehrfeld/Partiell"
Messmethode_Array = split(Messmethode,"/")

Dim Belichtungsprogramm,Belichtungsprogramm_Array	'Kennung =  6 / max. 9 Werte
Belichtungsprogramm = 	"unbekannt/Manuell/Programm (P)/Zeitautomatik (A)/Blendenautomatik (S)/Kreativprogramm/" & _
						"Aktionsprogramm/Portrait-Modus/Landschaft"
Belichtungsprogramm_Array = split(Belichtungsprogramm,"/")

Dim Lichtquelle,Lichtquelle_Array					'Kennung = 26 / max.12 Werte
Lichtquelle = 			"unbekannt/Tageslicht/Fluoreszens/Kunstlicht/Blitz/unbekannt/unbekannt/" & _
						"unbekannt/unbekannt/Sonnig/Bewlkt/Schatten"
Lichtquelle_Array = split(Lichtquelle,"/")

Dim Weissabgleich,Weissabgleich_Array				'Kennung = 34 / max. 2 Werte
Weissabgleich = 		"Automatik/Manuell"
Weissabgleich_Array = split(Weissabgleich,"/")

Dim Datentext_Array,Anzeigetext
Dim AbschnittListe,AbschnittR,Abschnitt

Dim bool_ProfEoR : bool_ProfEoR = 0
'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm
Dim Pos,element,DatumE

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if err > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbs") then
	SkriptName = Skript & ".vbs"
elseif objFS.FileExists(FF_GetScriptPath & "\" & Skript & ".vbe") then
	SkriptName = Skript & ".vbe"
else
	msgbox "Das Skript wurde umbenannt!",vbCritical,"Abbruch"
	exit sub
end if

ini_FileName = FF_GetScriptPath & "\MeckiScript\Bilddaten\Bilddaten."
if not objFS.FileExists(ini_FileName & "ini") then
	msgbox "Die Datei " & """" & "Bilddaten.ini" & """" & " ist nicht zu finden." & vbNewLine & _
		   "Die Skriptausfhrung wird abgebrochen!",vbExclamation,"Abbruch"
	exit sub
end if
if not objFS.FileExists(ini_FileName & "bak") then
	objFS.CopyFile ini_FileName & "ini",ini_FileName & "bak" ,true
end if

TempBild = FF_GetScriptPath & "\TempBild.jpg"

'** Start Dialog Bilddaten nach Word/Excel **
FF_AddDialog "Bilddaten nach Word/Excel",242,195
FF_AddControl "Bilddaten nach Word/Excel","Codepage","GROUP",181,124,56,38
FF_AddControl "Bilddaten nach Word/Excel","Auswahl","GROUP",5,5,118,56
FF_AddControl "Bilddaten nach Word/Excel","allCV","BOOL",9,16,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","allCV",16384
FF_AddControl "Bilddaten nach Word/Excel","alle Bilder der Computer-Ansicht","STATIC",21,15,90,11
FF_AddControl "Bilddaten nach Word/Excel","selCV","BOOL",9,26,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","selCV",16384
FF_AddControl "Bilddaten nach Word/Excel","markierte Bilder der Computer-Ansicht","STATIC",21,25,96,10
FF_AddControl "Bilddaten nach Word/Excel","allBL","BOOL",9,36,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","allBL",16384
FF_AddControl "Bilddaten nach Word/Excel","alle Bilder der aktiven Bilderliste","STATIC",21,35,96,10
FF_AddControl "Bilddaten nach Word/Excel","selBL","BOOL",9,46,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","selBL",16384
FF_AddControl "Bilddaten nach Word/Excel","markierte Bilder der aktiven Bilderliste","STATIC",22,45,96,11
FF_AddControl "Bilddaten nach Word/Excel","Word-Vorlage","GROUP",129,5,108,33
FF_AddControl "Bilddaten nach Word/Excel","bool_StdVorlage","BOOL",134,16,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","bool_StdVorlage",16384
FF_AddControl "Bilddaten nach Word/Excel","Standard-Dokumentvorlage","STATIC",147,15,80,10
FF_AddControl "Bilddaten nach Word/Excel","bool_Vorlage","BOOL",134,26,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","bool_Vorlage",16384
FF_AddControl "Bilddaten nach Word/Excel","p_Vorlage","SLEDIT",147,25,72,10
FF_SetControlStyle "Bilddaten nach Word/Excel","p_Vorlage",2049
FF_AddControl "Bilddaten nach Word/Excel","...","BUTTON",222,25,10,10
FF_AddControl "Bilddaten nach Word/Excel","Schrift","GROUP",129,40,108,21
FF_AddControl "Bilddaten nach Word/Excel","p_Schrift","FONT",134,47,60,10
FF_AddControl "Bilddaten nach Word/Excel","p_SGroesse","COMBO",200,47,20,10
FF_AddControl "Bilddaten nach Word/Excel","pkt","STATIC",222,47,10,10
FF_SetControlStyle "Bilddaten nach Word/Excel","pkt",1
FF_AddControl "Bilddaten nach Word/Excel","Bildparameter","GROUP",5,64,118,58
FF_AddControl "Bilddaten nach Word/Excel","Punktdichte","STATIC",9,73,62,11
FF_AddControl "Bilddaten nach Word/Excel","p_Dichte","COMBO",80,73,28,10
FF_AddControl "Bilddaten nach Word/Excel","dpi","STATIC",110,74,10,10
FF_SetControlStyle "Bilddaten nach Word/Excel","dpi",1
FF_AddControl "Bilddaten nach Word/Excel","Qualitt (0 = FF-Einstellung)","STATIC",9,84,68,10
FF_AddControl "Bilddaten nach Word/Excel","p_Qualitaet","SLEDIT",80,85,28,10
FF_SetControlStyle "Bilddaten nach Word/Excel","p_Qualitaet",8193
FF_AddControl "Bilddaten nach Word/Excel","%","STATIC",110,86,10,10
FF_SetControlStyle "Bilddaten nach Word/Excel","%",1
FF_AddControl "Bilddaten nach Word/Excel","Bildlage vertikal","STATIC",9,96,62,9
FF_AddControl "Bilddaten nach Word/Excel","p_BVertikal","COMBO",80,96,28,10
FF_AddControl "Bilddaten nach Word/Excel","Bildlage horizontal","STATIC",9,108,62,9
FF_AddControl "Bilddaten nach Word/Excel","p_BHorizontal","COMBO",80,108,28,10
FF_AddControl "Bilddaten nach Word/Excel","Layout","GROUP",129,64,108,58
FF_AddControl "Bilddaten nach Word/Excel","Anzahl Bilder pro Zeile","STATIC",134,73,54,10
FF_AddControl "Bilddaten nach Word/Excel","AnzBilder","COMBO",200,73,20,10
FF_AddControl "Bilddaten nach Word/Excel","Tabulatorweite","STATIC",134,85,48,10
FF_AddControl "Bilddaten nach Word/Excel","p_TabMM","SLEDIT",200,85,20,10
FF_SetControlStyle "Bilddaten nach Word/Excel","p_TabMM",8193
FF_AddControl "Bilddaten nach Word/Excel","mm","STATIC",221,84,10,11
FF_SetControlStyle "Bilddaten nach Word/Excel","mm",1
FF_AddControl "Bilddaten nach Word/Excel","bool_SWechsel","BOOL",134,97,8,8
FF_AddControl "Bilddaten nach Word/Excel","Seitenwechsel nach","STATIC",145,96,48,10
FF_AddControl "Bilddaten nach Word/Excel","p_SWechsel","SLEDIT",200,96,10,10
FF_SetControlStyle "Bilddaten nach Word/Excel","p_SWechsel",8193
FF_AddControl "Bilddaten nach Word/Excel","Zeile(n)","STATIC",213,96,21,10
FF_AddControl "Bilddaten nach Word/Excel","bool_LWAno","BOOL",134,107,8,8
FF_AddControl "Bilddaten nach Word/Excel","Leerwertanzeige unterdrcken","STATIC",145,106,75,10
FF_AddControl "Bilddaten nach Word/Excel","Initialisierungs-Datei","GROUP",5,124,170,38
FF_AddControl "Bilddaten nach Word/Excel","Profil","STATIC",9,134,18,10
FF_AddControl "Bilddaten nach Word/Excel","iniAbschnitt","COMBO",23,134,75,10
FF_AddControl "Bilddaten nach Word/Excel","Editieren","BUTTON",120,134,33,11
FF_AddControl "Bilddaten nach Word/Excel","Backup","BUTTON",102,147,33,11
FF_AddControl "Bilddaten nach Word/Excel","Restore","BUTTON",138,147,33,11
FF_AddControl "Bilddaten nach Word/Excel","Speichern","BUTTON",26,147,33,11
FF_AddControl "Bilddaten nach Word/Excel","Lschen","BUTTON",62,147,33,11
FF_AddControl "Bilddaten nach Word/Excel","Fortschritt","PROGRESS",5,166,232,6
FF_AddControl "Bilddaten nach Word/Excel","?","BUTTON",8,178,11,11
FF_AddControl "Bilddaten nach Word/Excel","Unterbrechen mit ","STATIC",83,178,44,11
FF_SetControlStyle "Bilddaten nach Word/Excel","Unterbrechen mit ",1
FF_AddControl "Bilddaten nach Word/Excel","Exceltabelle","BUTTON",164,178,33,11
FF_AddControl "Bilddaten nach Word/Excel","Worddatei","BUTTON",200,178,33,11
FF_AddControl "Bilddaten nach Word/Excel","&delete","BUTTON",1,1,1,1
FF_AddControl "Bilddaten nach Word/Excel","CodeP_Wert","COMBO",186,148,47,10
FF_AddControl "Bilddaten nach Word/Excel","MappingAktiv","BOOL",186,136,8,8
FF_SetControlStyle "Bilddaten nach Word/Excel","MappingAktiv",16384
FF_AddControl "Bilddaten nach Word/Excel","Mapping aktiv","STATIC",198,135,36,10
FF_AddControl "Bilddaten nach Word/Excel","Update","BUTTON",48,178,26,11
FF_AddControl "Bilddaten nach Word/Excel","|","STATIC",22,179,24,10
FF_SetControlStyle "Bilddaten nach Word/Excel","|",1
FF_AddControl "Bilddaten nach Word/Excel","Escape","BUTTON",126,179,26,9
'** End Dialog Bilddaten nach Word/Excel **

'Vorbelegung der Codepage-Werte
CodePw_Array = split(CodePwerte,"/")
for each CodePelement in CodePw_Array
	FF_SetControl "Bilddaten nach Word/Excel","CodeP_Wert",CodePelement
next

call Abschnittbenennung
call RegistryLesen

if FF_GetControl("Bilddaten nach Word/Excel","MappingAktiv") = 0 then
	FF_EnableControl "Bilddaten nach Word/Excel","CodeP_Wert", false
end if

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Bilddaten nach Word/Excel","iniAbschnitt", "" &_
						 "Auswahl des Profils"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Editieren", "" &_
						 "Editoraufruf fr das ausgewhlte Profil"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Speichern", "" &_
						 "Speichern des ausgewhlten Profils" & vbNewLine & _
						 "nach dem Editieren"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Lschen", "" &_
						 "Lschen des Inhalts des ausgewhlten Profils"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Backup", "" &_
						 "Sicherheitsbackup des ausgewhlten" & vbNewLine & _
						 "Profils anlegen"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Restore", "" &_
						 "Wiederherstellung des zuletzt angelegten" & vbNewLine & _
						 "Backups fr das ausgewhlte Profil"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","MappingAktiv", "" &_
						 "Mapping aktivieren, wenn Umlaute und" & vbNewLine & _
						 "Sonderzeichen falsch dargestellt werden"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","CodeP_Wert", "" &_
						 "Bei aktiviertem Mapping eine der" & vbNewLine & _
						 "Codepagenormen auswhlen und testen"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert." & vbNewLine & _
						 "Anderenfalls wird eine gekrzte Textversion angezeigt."
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Escape", "" &_
						 "Unterbrechung des Durchlaufs mit 'Escape'" & vbNewLine & _
						 "nur bei Erzeugung einer Worddatei mglich."
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Exceltabelle", "" &_
						 "Es wird eine Exceltabelle erzeugt."
	FF_SetControlTooltip "Bilddaten nach Word/Excel","Worddatei", "" &_
						 "Es wird eine Worddatei erzeugt."
end if

if Version_OK("3.40.52") then FF_SetTooltipDelay 3000
FF_ActivateControl "Bilddaten nach Word/Excel","&delete"
FF_SetDialogTimer "Bilddaten nach Word/Excel", 100

do
	Select Case FF_ShowDialog ("Bilddaten nach Word/Excel")
	Case "TIMER"
		FF_SetControl "Bilddaten nach Word/Excel" ,"|", "V " & Skriptversion
		FF_SetDialogTimer "Bilddaten nach Word/Excel", 0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "allCV"		'Auswahl alle in der Comp.-Ansicht
		Auswahl = 0
		FF_SetControl "Bilddaten nach Word/Excel","allCV",1
		FF_SetControl "Bilddaten nach Word/Excel","selCV",0
		FF_SetControl "Bilddaten nach Word/Excel","allBL",0
		FF_SetControl "Bilddaten nach Word/Excel","selBL",0
	Case "selCV"		'Auswahl markierte in der Comp.-Ansicht
		Auswahl = 1
		FF_SetControl "Bilddaten nach Word/Excel","allCV",0
		FF_SetControl "Bilddaten nach Word/Excel","selCV",1
		FF_SetControl "Bilddaten nach Word/Excel","allBL",0
		FF_SetControl "Bilddaten nach Word/Excel","selBL",0	
	Case "allBL"		'Auswahl alle in der aktuellen Bilderliste
		Auswahl = 2
		FF_SetControl "Bilddaten nach Word/Excel","allCV",0
		FF_SetControl "Bilddaten nach Word/Excel","selCV",0
		FF_SetControl "Bilddaten nach Word/Excel","allBL",1
		FF_SetControl "Bilddaten nach Word/Excel","selBL",0	
	Case "selBL"		'Auswahl markierte in der aktuellen Bilderliste
		Auswahl = 3
		FF_SetControl "Bilddaten nach Word/Excel","allCV",0
		FF_SetControl "Bilddaten nach Word/Excel","selCV",0
		FF_SetControl "Bilddaten nach Word/Excel","allBL",0
		FF_SetControl "Bilddaten nach Word/Excel","selBL",1
	Case "bool_StdVorlage"
		FF_SetControl "Bilddaten nach Word/Excel","bool_StdVorlage",1
		FF_SetControl "Bilddaten nach Word/Excel","bool_Vorlage",0
	Case "bool_Vorlage"
		FF_SetControl "Bilddaten nach Word/Excel","bool_StdVorlage",0
		FF_SetControl "Bilddaten nach Word/Excel","bool_Vorlage",1
	Case "..."
		if len(Vorlagenname) > 3 then
			Pos = InStrRev(Vorlagenname,"\")
			Pfadvorschlag = left(Vorlagenname,Pos)
		else
			Pfadvorschlag = FF_GetScriptPath & "\MeckiScript\Bilddaten\"
		end if
		FF_SetCurrentPath Pfadvorschlag
		Eingabe = FF_EnterFileName(true, "*.dot;*.dotx")
		if objFS.FileExists(Eingabe) then Vorlagenname = Eingabe
		Pos = InStrRev(Vorlagenname,"\")
		p_Vorlage = mid(Vorlagenname,Pos+1)
		FF_SetControl "Bilddaten nach Word/Excel","p_Vorlage",p_Vorlage
	Case "iniAbschnitt"
		call ini_WerteAuslesen
	Case "Editieren"
		WshShell.Run "notepad " + ini_FileName & "ini",1,true
		call Abschnittbenennung
		if instr(AbschnittListe,"/" & Abschnitt & "/") > 0 then
			FF_SetControl "Bilddaten nach Word/Excel","iniAbschnitt",Abschnitt
		end if
		call ini_WerteAuslesen
		Antwort = msgbox("Soll ein neues Backup angelegt werden?",vbQuestion or vbYesNo,"Backup")
		if Antwort = vbYes then objFS.CopyFile ini_FileName & "ini",ini_FileName & "bak" ,true
	Case "Backup"
		if objFS.FileExists(ini_FileName & "bak") then
			DatumE = FF_GetFileDate (ini_FileName & "bak", 1)
			Antwort = msgbox("Soll das vorhandene Backup vom" & vbNewLine & DatumE & vbNewLine & "berschrieben werden?",vbQuestion or vbYesNo,"Backup")
			if Antwort = vbYes then	objFS.CopyFile ini_FileName & "ini",ini_FileName & "bak" ,true
		else
			objFS.CopyFile ini_FileName & "ini",ini_FileName & "bak" ,true
		end if
	Case "Restore"
		if objFS.FileExists(ini_FileName & "bak") then
			Antwort = msgbox("Soll die vorhandene ini-Datei berschrieben werden?",vbQuestion or vbYesNo,"Backup")
			if Antwort = vbYes then	
				objFS.CopyFile ini_FileName & "bak",ini_FileName & "ini" ,true
				call Abschnittbenennung
			end if
		else
			msgbox "Es besteht kein Backup!",vbInformation,"Hinweis"
		end if
	Case "Speichern"
		call EWspeichern ("S")
	Case "Lschen"
		call EWspeichern ("L")
	Case "MappingAktiv"
		if FF_GetControl("Bilddaten nach Word/Excel","MappingAktiv") = 0 then
			FF_EnableControl "Bilddaten nach Word/Excel","CodeP_Wert", false
		else
			FF_EnableControl "Bilddaten nach Word/Excel","CodeP_Wert", true
		end if
	Case "?"
		'FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\Bilddaten\Bilddaten nach Word_Excel.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Exceltabelle"
		call WerteAuslesen
		if not Abbruch then call Kontrolle
		if not Abbruch then
			ExcelT = true
			call Datentext_Lesen
			FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",1
			call Bildschleife
			exit do
		end if
		Abbruch = false
	Case "Worddatei"
		call WerteAuslesen
		if not Abbruch then call Kontrolle
		if not Abbruch then
			call Datentext_Lesen
			FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",1
			call Bildschleife
			exit do
		end if
		Abbruch = false
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Bilddaten nach Word/Excel")
if SkriptKill then	'ggf. Skript 'Ordner lschen' komplett entfernen
	call KillSkript
end if

End sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim TBreite	: TBreite = LaengeMax * 2.6 + 10
const THoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",TBreite,THoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,TBreite,THoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",TBreite/2-15,THoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\MeckiScript\Bilddaten\Bilddaten.ini"		'Datei
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\Bilddaten"						'Ordner
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

'Auswahl
if FF_GetControl ("Bilddaten nach Word/Excel","allCV") = 1 then Auswahl = 0	'alle Dateien der Computeransicht
if FF_GetControl ("Bilddaten nach Word/Excel","selCV") = 1 then Auswahl = 1	'markierte Dateien der Computeransich
if FF_GetControl ("Bilddaten nach Word/Excel","allBL") = 1 then Auswahl = 2	'alle Dateien der aktuellen Bilderliste
if FF_GetControl ("Bilddaten nach Word/Excel","selBL") = 1 then Auswahl = 3	'markierte Dateien der aktuellen Bilderliste

'Word-Dokumentvorlage
bool_StdVorlage	= FF_GetControl ("Bilddaten nach Word/Excel","bool_StdVorlage")
bool_Vorlage	= FF_GetControl ("Bilddaten nach Word/Excel","bool_Vorlage")
p_Vorlage		= FF_GetControl ("Bilddaten nach Word/Excel","p_Vorlage")

'Schrift
p_Schrift		= FF_GetControl ("Bilddaten nach Word/Excel","p_Schrift")
p_SGroesse		= FF_GetControl ("Bilddaten nach Word/Excel","p_SGroesse")

'Bildparameter
p_Dichte		= FF_GetControl ("Bilddaten nach Word/Excel","p_Dichte")
p_Qualitaet		= FF_GetControl ("Bilddaten nach Word/Excel","p_Qualitaet")
if FF_GetControl ("Bilddaten nach Word/Excel","p_BVertikal") = "Oben"  then BildVertikal = 0
if FF_GetControl ("Bilddaten nach Word/Excel","p_BVertikal") = "Mitte" then BildVertikal = 1
if FF_GetControl ("Bilddaten nach Word/Excel","p_BVertikal") = "Unten" then BildVertikal = 3
if FF_GetControl ("Bilddaten nach Word/Excel","p_BHorizontal") = "Links"  then BildHorizontal = 0
if FF_GetControl ("Bilddaten nach Word/Excel","p_BHorizontal") = "Mitte"  then BildHorizontal = 1
if FF_GetControl ("Bilddaten nach Word/Excel","p_BHorizontal") = "Rechts" then BildHorizontal = 2

'Layout
AnzBilder		= FF_GetControl ("Bilddaten nach Word/Excel","AnzBilder")
p_TabMM			= FF_GetControl ("Bilddaten nach Word/Excel","p_TabMM")
if p_TabMM = "" then p_TabMM = 0
Tabulator = int(p_TabMM/25.4*72)	'px

bool_SWechsel	= FF_GetControl ("Bilddaten nach Word/Excel","bool_SWechsel")
p_SWechsel		= FF_GetControl ("Bilddaten nach Word/Excel","p_SWechsel")
if p_SWechsel = "" then p_SWechsel = 0
p_SWechsel = p_SWechsel * 1
bool_LWAno		= FF_GetControl ("Bilddaten nach Word/Excel","bool_LWAno")

'ini-Datei
Abschnitt = FF_GetControl("Bilddaten nach Word/Excel","iniAbschnitt")

'Codepage
MappingAktiv 	= FF_GetControl ("Bilddaten nach Word/Excel","MappingAktiv")
CodeP_Wert 		= FF_GetControl ("Bilddaten nach Word/Excel","CodeP_Wert")
CodePa_Array = split(CodePauswahl,"/")
for n = 0 to ubound(CodePw_Array)
	if CodePw_Array(n) = CodeP_Wert then
		Codepage = CodePa_Array(n)
		exit for
	end if
next 
if Codepage = "Auto" then MappMerker = "Auto"

End Sub
'------------------------------------------------------------------------
Sub ini_WerteAuslesen
'Profilwerte in ini-Datei ermitteln
Dim Ini_Datei,Zeile,PosZ,PosK,PosKZ,AbschnittD,Einstellung,AbWerte,Array,i,msg
AbWerte = false

Abschnitt = FF_GetControl ("Bilddaten nach Word/Excel","iniAbschnitt")			'Abschnitt ermitteln
Set Ini_Datei = objFS.OpenTextFile(ini_FileName & "ini", ForReading, False)

Do While Ini_Datei.AtEndOfStream <> True
	Zeile = Ini_Datei.ReadLine

	if instr(Zeile,"###+++ Datenbezeichnungen Anfang ") > 0 then
		PosZ = instr(Zeile,"/")
		
		if PosZ > 0 then 
			PosK = instr(PosZ+1,Zeile,"(")
			if PosK > 0 then
				AbschnittD = trim(mid(Zeile,PosZ+1,PosK-PosZ-1))
			else
				AbschnittD = trim(mid(Zeile,PosZ+1))
			end if
		end if

		if Abschnitt = AbschnittD then
			if PosK > 0 then
				Einstellung = trim(mid(Zeile,PosK+1))
				PosKZ = instr(Einstellung,")")
				if PosKZ > 0 then
					Einstellung = trim(left(Einstellung,PosKZ-1))
				end if
				AbWerte = true
				exit do
			else
				exit do
			end if
		end if
		
	end if
Loop

Ini_Datei.Close
if not AbWerte then exit sub

'Profilwerte bernehmen
Array = split(Einstellung,",")
for i = 0 to ubound(Array)
	Array(i) = trim(Array(i))
	if i = 0 and Array(i) <> "" then 
		FF_SetControl "Bilddaten nach Word/Excel","p_Schrift",Array(i)
	end if
	if i > 0 and IsNumeric(Array(i)) then
		select case i
			case 1
				'p_SGroesse
				FF_SetControl "Bilddaten nach Word/Excel","p_SGroesse",Array(i)
			case 2
				'AnzBilder
				FF_SetControl "Bilddaten nach Word/Excel","AnzBilder",Array(i)
			case 3
				'p_TabMM
				FF_SetControl "Bilddaten nach Word/Excel","p_TabMM",Array(i)
				Tabulator = int(Array(i)/25.4*72)
			case 4
				'bool_SWechsel
				if Array(i) = 0 then
					FF_SetControl "Bilddaten nach Word/Excel","bool_SWechsel",0
				else
					FF_SetControl "Bilddaten nach Word/Excel","bool_SWechsel",1
					'p_SWechsel
					FF_SetControl "Bilddaten nach Word/Excel","p_SWechsel",Array(i)
				end if
			case 5
				'bool_LWAno
				if Array(i) = 0 then
					FF_SetControl "Bilddaten nach Word/Excel","bool_LWAno",0
				else
					FF_SetControl "Bilddaten nach Word/Excel","bool_LWAno",1
				end if
		end select
	end if
next

End Sub
'------------------------------------------------------------------------
Sub Kontrolle
Dim Text

'Versionstest fr Auswahl
if Auswahl > 1 then		'Auswahl aktiver Bilderliste
	if not Version_OK("2.90.0") then
		msgbox "Um die Auswahl aktiver Bilderlisten nutzen zu knnen" & vbNewLine & _
			   "ist mindestens FixFoto-Version 2.90 erforderlich.",vbCritical,"Hinweis"
		Abbruch = true
		exit sub
	end if
end if

'Bilder vorhanden?
Bilder = FF_GetSelection(Auswahl)
if Auswahl = 0 or Auswahl = 2 then Text = "vorhanden!" else Text = "markiert!"
if len(Bilder) = 0 then
	msgbox "Es ist kein Bild " & Text,vbExclamation,"Meldung"
	Abbruch = true
	exit sub
end if

'Vorlage vorhanden wenn gefordert
if bool_Vorlage = 1 and not objFS.FileExists(Vorlagenname) then
	msgbox "Es muss eine Vorlage ausgewhlt sein!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

'Schriftgre
if p_SGroesse < 2 or p_SGroesse > 14 then
	msgbox "Bitte die Schriftgre kontrollieren." & vbNewLine & _
		   "Sie sollte 4 und 14 pkt betragen!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

'Anzahl Bilder pro Zeile
AnzBilder = AnzBilder * 1
if (AnzBilder < 1) or (AnzBilder > AnzMax) then
	msgbox "Bitte Anzahl Bilder pro Zeile kontrollieren." & vbNewLine & _
		   "Sie muss zwischen 1 und " & AnzMax & " liegen!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

'Tabulatorweite
if p_TabMM < 5 then
	msgbox "Bitte die Tabulatorweite kontrollieren." & vbNewLine & _
		   "Sie sollte mindestens 5 mm betragen!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

'Bildqualitt
if p_Qualitaet < 60 and p_Qualitaet <> 0 or p_Qualitaet > 100 then
	msgbox "Die Bildqualitt darf 0 sein, wenn die" & vbNewLine & _
		   "FF-Einstellung bernommmen werden soll" & vbNewLine & _
		   "oder sie muss zwischen 60 und 100 % betragen.",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

'Anz. Bildpaare bei erzw. Seitenwechsel
if bool_SWechsel = 1 and p_SWechsel < 1 then
	msgbox "Die Anzahl der Bildpaare bei erzwungenem" & vbNewLine & _
		   "sollte mindestens 1 sein!",vbInformation,"Hinweis"
	Abbruch = true
	exit sub
end if

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel
Dim Pos,i

'### Werte auslesen

'Auswahl
Auswahl = FF_GetProfile (RegSchluessel,"Auswahl")
if Auswahl = "" then Auswahl = 1

'Vorlage
bool_StdVorlage = FF_GetProfile (RegSchluessel,"bool_StdVorlage")
if bool_StdVorlage = "" then bool_StdVorlage = 1
'bool_Vorlage = Kehrwert bool_StdVorlage

Vorlagenname = FF_GetProfile (RegSchluessel,"Vorlagenname")
if Vorlagenname = "" then Vorlagenname = FF_GetScriptPath & "\MeckiScript\Bilddaten\Bilddaten.dot"
if objFS.FileExists(Vorlagenname) then
	Pos = InStrRev(Vorlagenname,"\")
	p_Vorlage = mid(VorlagenName,Pos+1)
else
	p_Vorlage = ""
	Vorlagenname = ""
end if

'Schrift
p_Schrift= FF_GetProfile (RegSchluessel,"p_Schrift")
if p_Schrift = "" then p_Schrift = "Arial"

p_SGroesse= FF_GetProfile (RegSchluessel,"p_SGroesse")
if p_SGroesse = "" then p_SGroesse = 8

'Bildwerte
p_Dichte= FF_GetProfile (RegSchluessel,"p_Dichte")
if p_Dichte = "" then p_Dichte = 200

p_Qualitaet= FF_GetProfile (RegSchluessel,"p_Qualitaet")
if p_Qualitaet = "" then p_Qualitaet = 80

BildVertikal = FF_GetProfile (RegSchluessel,"BildVertikal")
if BildVertikal = "" then BildVertikal = 3

BildHorizontal = FF_GetProfile (RegSchluessel,"BildHorizontal")
if BildHorizontal = "" then BildHorizontal = 0

'Layout
AnzBilder = FF_GetProfile (RegSchluessel,"AnzBilder")
if AnzBilder = "" then AnzBilder = 2
AnzBilder = AnzBilder * 1

p_TabMM = FF_GetProfile (RegSchluessel,"p_TabMM")
if p_TabMM = "" then p_TabMM = 35

bool_SWechsel = FF_GetProfile (RegSchluessel,"bool_SWechsel")
if bool_SWechsel = "" then bool_SWechsel = 0

p_SWechsel = FF_GetProfile (RegSchluessel,"p_SWechsel")
if p_SWechsel = "" then p_SWechsel = 2

bool_LWAno = FF_GetProfile (RegSchluessel,"bool_LWAno")
if bool_LWAno = "" then bool_LWAno = 0

'ini-Datei
AbschnittR = FF_GetProfile (RegSchluessel,"AbschnittR")

'Codepage
MappingAktiv = FF_GetProfile (RegSchluessel,"MappingAktiv")
if MappingAktiv = "" then MappingAktiv = 0
CodeP_Wert = FF_GetProfile (RegSchluessel,"CodeP_Wert")
if CodeP_Wert = "" then CodeP_Wert = "Auto"

'### Werte eintragen

'Auswahl
select case Auswahl
	Case 0
		FF_SetControl "Bilddaten nach Word/Excel","allCV",1
	Case 1
		FF_SetControl "Bilddaten nach Word/Excel","selCV",1
	Case 2
		FF_SetControl "Bilddaten nach Word/Excel","allBL",1
	Case 3
		FF_SetControl "Bilddaten nach Word/Excel","selBL",1
End select

'Vorlage
if bool_StdVorlage = 1 then
	FF_SetControl "Bilddaten nach Word/Excel","bool_StdVorlage",1
else
	FF_SetControl "Bilddaten nach Word/Excel","bool_Vorlage",1
end if
FF_SetControl "Bilddaten nach Word/Excel","p_Vorlage",p_Vorlage

'Schrift
FF_SetControl "Bilddaten nach Word/Excel","p_Schrift",p_Schrift
for i = 2 to 14
	FF_SetControl "Bilddaten nach Word/Excel","p_SGroesse",i
next
FF_SetControl "Bilddaten nach Word/Excel","p_SGroesse",p_SGroesse

'Bildwerte
WerteArray = split(Dichte,"/")
for each WerteElement in WerteArray
	FF_SetControl "Bilddaten nach Word/Excel","p_Dichte",WerteElement
next
FF_SetControl "Bilddaten nach Word/Excel","p_Dichte",p_Dichte

FF_SetControl "Bilddaten nach Word/Excel","p_Qualitaet",p_Qualitaet

WerteArray = split(Vertikal,"/")
for each WerteElement in WerteArray
	FF_SetControl "Bilddaten nach Word/Excel","p_BVertikal",WerteElement
next
select case BildVertikal
	case 0
		FF_SetControl "Bilddaten nach Word/Excel","p_BVertikal","Oben"
	case 1
		FF_SetControl "Bilddaten nach Word/Excel","p_BVertikal","Mitte"
	case 3
		FF_SetControl "Bilddaten nach Word/Excel","p_BVertikal","Unten"
end select

WerteArray = split(Horizontal,"/")
for each WerteElement in WerteArray
	FF_SetControl "Bilddaten nach Word/Excel","p_BHorizontal",WerteElement
next
select case BildHorizontal
	case 0
		FF_SetControl "Bilddaten nach Word/Excel","p_BHorizontal","Links"
	case 1
		FF_SetControl "Bilddaten nach Word/Excel","p_BHorizontal","Mitte"
	case 2
		FF_SetControl "Bilddaten nach Word/Excel","p_BHorizontal","Rechts"
end select

'Layout
for i = 1 to AnzMax : FF_SetControl "Bilddaten nach Word/Excel","AnzBilder",i : next
FF_SetControl "Bilddaten nach Word/Excel","AnzBilder",AnzBilder

FF_SetControl "Bilddaten nach Word/Excel","p_TabMM",p_TabMM

FF_SetControl "Bilddaten nach Word/Excel","bool_SWechsel",bool_SWechsel
FF_SetControl "Bilddaten nach Word/Excel","p_SWechsel",p_SWechsel

FF_SetControl "Bilddaten nach Word/Excel","bool_LWAno",bool_LWAno

'ini-Datei
if instr(AbschnittListe,"/" & AbschnittR & "/") > 0 then
	FF_SetControl "Bilddaten nach Word/Excel","iniAbschnitt",AbschnittR
	call ini_WerteAuslesen
end if

'Codepage
FF_SetControl "Bilddaten nach Word/Excel","MappingAktiv",MappingAktiv
FF_SetControl "Bilddaten nach Word/Excel","CodeP_Wert",CodeP_Wert

End Sub
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"Auswahl",Auswahl

FF_WriteProfile RegSchluessel,"bool_StdVorlage",bool_StdVorlage
FF_WriteProfile RegSchluessel,"Vorlagenname",Vorlagenname

FF_WriteProfile RegSchluessel,"p_Schrift",p_Schrift
FF_WriteProfile RegSchluessel,"p_SGroesse",p_SGroesse

FF_WriteProfile RegSchluessel,"p_Dichte",p_Dichte
FF_WriteProfile RegSchluessel,"p_Qualitaet",p_Qualitaet
FF_WriteProfile RegSchluessel,"BildVertikal",BildVertikal
FF_WriteProfile RegSchluessel,"BildHorizontal",BildHorizontal

FF_WriteProfile RegSchluessel,"AnzBilder",AnzBilder
FF_WriteProfile RegSchluessel,"p_TabMM",p_TabMM
FF_WriteProfile RegSchluessel,"bool_SWechsel",bool_SWechsel
FF_WriteProfile RegSchluessel,"p_SWechsel",p_SWechsel
FF_WriteProfile RegSchluessel,"bool_LWAno",bool_LWAno

FF_WriteProfile RegSchluessel,"AbschnittR",Abschnitt

FF_WriteProfile RegSchluessel,"MappingAktiv",MappingAktiv
FF_WriteProfile RegSchluessel,"CodeP_Wert",CodeP_Wert

End Sub
'---------------------------------------------------------------------
Sub Bildschleife
Dim msg

'Bilder in Array eintragen
Array = split(Bilder, vbNewLine)
img = ubound(Array)
redim EArrayG(img,ubound(Datentext_Array))	'### Excel

'Kontrolle ob alle Bilder vorhanden sind
for n = 0 to img
	if not objFS.FileExists(Array(n)) then
		msg = "Das Bild" & vbNewLine & Array(n) & vbNewLine & "ist nicht vorhanden."
		if Auswahl = 2 or Auswahl = 3 then
			msg = msg & vbNewLine & vbNewLine & "Unbedingt in der Bilderliste das " & n+1 & ". Bild berprfen!"
		end if
		msgbox msg,vbCritical,"Abbruch"
		exit sub
	end if
next

if ExcelT then
	call ExcelEintrag
else
	call WordEintrag
end if

End Sub
'---------------------------------------------------------------------
Sub ExcelEintrag
Dim Image

	for n = 0 to img
	
		if instr(Bildfilter,"." & ucase(objFS.GetExtensionName(Array(n))) & ".") > 0 then Image = true else Image = false
		
		'vorzeitiger Abbruch? (nicht bei Excel)
'		if FF_CheckKey() = 8 then 	'8 = Backspace
'			Antwort = msgbox("Von " & img +1 & " Bildern wurden bisher " & n & _
'						 " Bilddaten in Excel eingetragen." & vbNewLine & vbNewLine & _
'						 "Soll die weitere bertragung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
'			if Antwort = vbYes then	exit for
'		end if
		
		if Image then 
			FF_LoadImage Array(n)
			call BildDaten_Sichern
		end if
		
		FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",(n+1)/(img+1)*100
	next

call ExcelTabelle
		
End Sub
'---------------------------------------------------------------------
Sub WordEintrag
'Kontrolle ob Word installiert ist
on error resume next
set word = CreateObject("Word.Application")
if err > 0 then
    msgBox "WORD kann nicht gestartet werden." & vbNewLine & _
			"Das Skript wird abgebrochen!",vbExclamation,"Abbruch"
	exit sub
end If
on error goto 0

with word
	'### Vorbereitung
	.windowstate = 1
	.visible = false
	if bool_StdVorlage = 1 then
		.Documents.Add
	else
		.Documents.Add Vorlagenname
	end if

	.Selection.EndKey 6													'Cursor an das Ende des Dokuments setzen
	if .Selection.Information(wdHorizontalPositionRelativeToTextBoundary) * 1 <> 0 then		'ggf. neue Zeile
		.Selection.TypeParagraph
		.Selection.EndKey 6
	end if
	.Selection.Style = word.ActiveDocument.Styles("Standard")			'Formatvorlage fr Bilderbeschriftung setzen

	'### Textbreite ermitteln
	.Selection.ParagraphFormat.Alignment = wdAlignParagraphRight		'rechtsbndig
	TBreitePx = .Selection.Information(wdHorizontalPositionRelativeToTextBoundary)	'Textbreite
	.Selection.ParagraphFormat.Alignment = wdAlignParagraphLeft			'linksbndig
end with

BildLaenge = (TBreitePx - (8 + AnzBilder) * (AnzBilder)) / AnzBilder * 2.54 / 72

call Bildeintrag

End Sub
'---------------------------------------------------------------------
Sub Bildeintrag
'Bilder nebeneinander darstellen und darunter jeweils die Bilddaten
Dim i,z,b,Image

with word.Selection
	'### Bilder und Beschriftungen einfgen
	for n = 0 to img
		if instr(Bildfilter,"." & ucase(objFS.GetExtensionName(Array(n))) & ".") > 0 then Image = true else Image = false
		
		'vorzeitiger Abbruch?
		if FF_CheckKey() = 8 then 	'8 = Backspace
			Antwort = msgbox("Von " & img +1 & " Bildern wurden bisher " & n & _
						 " Bilder in Word eingetragen." & vbNewLine & vbNewLine & _
						 "Soll die weitere bertragung abgebrochen werden?",vbYesNo or vbQuestion,"Abfrage")
			if Antwort = vbYes then	exit for
		end if
		
		z = n mod AnzBilder	+ 1
		b = z * 2 - 1

		if z = 1 then

			'Beschriftungszellen verbinden und ggf. Seitenwechsel
			if n > 0 then
				for i = 1 to AnzBilder
					.Tables(1).Cell(1, i).select
					.MoveRight 1, 1, 1
					.Cells.Merge
	
					.Cells.VerticalAlignment = BildVertikal			'vertikal					
					.ParagraphFormat.Alignment = BildHorizontal		'horizontal
					
					.Tables(1).Cell(2, i).select
					.MoveRight 1, 1, 1
					.Cells.Merge
				next
				.EndKey 6
				if bool_SWechsel = 1 and (n mod (AnzBilder * p_SWechsel) = 0)then
					.InsertBreak wdPageBreak					'erzwungener Seitenwechsel nach angegebenen Bildzeilen
				end if
			end if
			
			'nchste Tabelle einfgen und Tabellenrahmen unsichtbar machen
			.TypeParagraph
			.Tables.Add word.Selection.Range, 2, AnzBilder * 2	'Tabelle hinzufgen ohne automatische Grenanpassung

			With .Tables(1)										'Tabellenrahmen unsichtbar machen
				for i = -1 to -8 step -1 : .Borders(i).LineStyle = 0 :	next
			End With
			
		end if
		
		'### Bilder eintragen
		if Image then 
			FF_LoadImage Array(n)
			call BildDaten_Sichern
			call Bildbearbeitung
		end if
		
		FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",(n+1)/(img+1)*100
		
		.Tables(1).Columns(b).SetWidth BspBreite, wdAdjustNone	'Spaltenbreite festlegen
		.Tables(1).Columns(b+1).SetWidth AgSpalte, wdAdjustNone	'Spaltenbreite festlegen
		
		.Tables(1).Cell(1, b).select
		.MoveLeft 1, 1

		if Image then
			.InlineShapes.AddPicture TempBild			'Bild einfgen
			
			.Tables(1).Cell(2, b).select
			call Beschriftung							'beschriften
		else
			.TypeText "Kein Bild!" & vbNewLine & vbNewLine & objFS.GetFileName(Array(n)) & vbNewLine
		end if

		.EndKey 6												'Cursor an das Ende des Dokuments setzen
		
	next
	
	const debug = false		'### true nur zum Testen
	if debug = true then

	'Beschriftungszellen verbinden
		for i = 1 to AnzBilder
			.Tables(1).Cell(1, i).select
			.MoveRight 1, 1, 1
			.Cells.Merge
			.Cells.VerticalAlignment = BildVertikal			'vertikal					
			.ParagraphFormat.Alignment = BildHorizontal		'horizontal

			.Tables(1).Cell(2, i).select
			.MoveRight 1, 1, 1
			.Cells.Merge
		next
	
	'Schriftart, Schriftgre und Tabulatoren setzen
		.WholeStory
	    .Font.Name = p_Schrift
	   	.Font.Size = p_SGroesse
		.ParagraphFormat.TabStops.Add Tabulator,0,0
 
   	'Ende
		.HomeKey 6											'Cursor auf Dokumentenanfang
	
	end if
	
end with

word.visible = true
Set word = Nothing           							'Wordobjekt freigeben

if objFS.FileExists(TempBild) then						'Temp-Bild lschen
	objFS.DeleteFile TempBild,true
end if

End Sub
'---------------------------------------------------------------------
Sub Bildbearbeitung
Dim B_Breite,B_Hoehe,SV_BzuH

const ySchaerfe = 20
const rgbSchaerfe = 20
FF_SetDPI 72

SV_BzuH = FF_GetImageWidth / FF_GetImageHeight
if SV_BzuH > 1 then
	B_Breite = round(BildLaenge * p_Dichte / 2.54)
	AgSpalte = 8 * 1
	BspBreite = round((BildLaenge + .25) * 72 / 2.54)
else
	B_Breite = round(BildLaenge / SV_BzuH * p_Dichte / 2.54)
	AgSpalte = round((BildLaenge + .25) * 72 / 2.54 * (1 - SV_BzuH)) + 8
	BspBreite = round((BildLaenge + .25) * SV_BzuH * 72 / 2.54)
end if
B_Hoehe =  round(B_Breite / SV_BzuH)
'Msgbox "Bildbreite = " & B_Breite & vbNewLine & "Bildhhe = " & B_Hoehe & vbNewLine & "Spaltenbreite = " & BspBreite

FF_HQScale B_Breite,B_Hoehe,true
FF_YSharp ySchaerfe
FF_Sharp rgbSchaerfe,true,true,true

FF_KillExif
FF_KillIPTC
FF_SaveImage TempBild,p_Qualitaet

End Sub
'---------------------------------------------------------------------
Sub BildDaten_Sichern
Dim element,Pos,Kennung,PosE,Ergebnis,objFile,Vorspann,Bild,f
Dim BildErgebnis,e	'### Excel

if MappingAktiv = 1 and MappMerker = "Auto" then call Mapping
SetLocale("de-de")	'Lndercode "Deutsch - Deutschland"

Anzeigetext = ""
for each element in Datentext_Array
	Pos = instr(element,"=")
	if Pos = 0 then
		Anzeigetext = Anzeigetext & element & vbNewLine
	else
		Vorspann = left(element,Pos-1)
		Kennung = mid(element,Pos+1)
		select case trim(Kennung)
			case "a"
				Ergebnis = objFS.GetParentFolderName(Array(n))
				PosE = InStrRev(Ergebnis,"\")
				if PosE > 0 then Ergebnis = "..." & mid(Ergebnis,PosE)
			case "b"
				Ergebnis = objFS.GetBaseName(Array(n))
			case "c"
				Ergebnis = objFS.GetFileName(Array(n))
			Case "d"
				set objFile = objFS.GetFile(Array(n))
				Ergebnis = FormatNumber(objFile.Size,0,,,-2)
			case "e"
				Ergebnis = FF_GetImageFileWidth (Array(n)) & " x " & FF_GetImageFileHeight (Array(n))
			case "f"
				Ergebnis = FF_GetFileDate (Array(n), 1)
				Ergebnis = mid(Ergebnis,9,2) & "." & mid(Ergebnis,6,2) & "." & left(Ergebnis,4) & mid(Ergebnis,11)
			case "g"
				Ergebnis = FF_GetFileDate (Array(n), 2)
				Ergebnis = mid(Ergebnis,9,2) & "." & mid(Ergebnis,6,2) & "." & left(Ergebnis,4) & mid(Ergebnis,11)
			case "h"
				Ergebnis = objFS.GetParentFolderName(Array(n))
			case "i"
				Set f = objFS.GetFile(Array(n))
				Ergebnis = f.ShortPath
				PosE = InStrRev(Ergebnis,"\")
				if PosE > 0 then Ergebnis = left(Ergebnis,PosE-1)
			case "k"
				Ergebnis = n + 1
		case else
			if IsNumeric(Kennung) then
				Kennung = Kennung * 1
				
				if Kennung < 38 then					'Exif-Daten: FF_GetExifTag(Tag)
					if MappingAktiv = 0 then
						Ergebnis = FF_GetExifTag(Tags_Array(Kennung))
					else
						Ergebnis = FF_MapCodePage(FF_GetExifTag(Tags_Array(Kennung)),Codepage,0)
					end if
					if Kennung = 13 or Kennung = 25 then	'Lngen- und Breitengrad
						Ergebnis = replace(Ergebnis,"?","")
					end if
				elseif Kennung < 43 then				'Erweiterte Exif-Daten: FF_GetExifTagAdvanced(Tag)
					if MappingAktiv = 0 then
						Ergebnis = FF_GetExifTagAdvanced(Tags_Array(Kennung))
					else
						Ergebnis = FF_MapCodePage(FF_GetExifTagAdvanced(Tags_Array(Kennung)),Codepage,0)
					end if
				elseif Kennung < 69 then				'IPTC-Daten: FF_GetIPTC(Tag)
					if MappingAktiv = 0 then
						Ergebnis = FF_GetIPTC(Tags_Array(Kennung))
					else
						Ergebnis = FF_MapCodePage(FF_GetIPTC(Tags_Array(Kennung)),Codepage,0)
					end if
				else
					Ergebnis = "Datenfehler!"
					msgbox  "In der Datei 'Datenbezeichnungen.ini' liegt in" & vbNewLine & _
							"der Textzeile mit '" & element & "' ein Fehler vor!",vbExclamation,"Warnung"
					exit sub
				end if
			else
				Ergebnis = "Datenfehler!"
				Anzeigetext = Anzeigetext & Ergebnis
				msgbox  "In der Datei 'Datenbezeichnungen.ini' liegt in" & vbNewLine & _
						"der Textzeile mit '" & element & "' ein Fehler vor!",vbExclamation,"Warnung"
				exit sub
			end if
		end select
		
		Ergebnis = Bereinigung (Ergebnis)
		
		if IsNumeric(Kennung) then
		select case Kennung							'### Formatierung

			case 1,2,5,7,10,11,14,15,22,27,31,33,41	'Punkt ersetzen durch Komma
				if IsNumeric(Ergebnis) then
				
				PosE = instr(Ergebnis,".")
				if PosE > 0 then
					Ergebnis = left(Ergebnis,PosE-1) & "," & mid(Ergebnis,PosE+1)
				end if

				select case Kennung
					case 1,2,15,31					'keine Nachkommastelle
						Ergebnis = FormatNumber(Ergebnis,0,,,-2)
					case 14							'1 Nachkommastelle
						Ergebnis = FormatNumber(Ergebnis,1,,,-2)
					case 5,10,11,22,27,33			'2 Nachkommastellen
						Ergebnis = FormatNumber(Ergebnis,2,,,-2)
					case 7							'bei < 1 Bruch darstellen
						if Ergebnis < 1 then
							Ergebnis = "1/" & int(1 / Ergebnis)
						else
							Ergebnis = FormatNumber(Ergebnis,2,,,-2)
						end if
					case else
				end select
				
				end if
			case 0										'Messmethode codiert
				if IsNumeric(Ergebnis) then
				if Ergebnis < 7 then
					Ergebnis = Messmethode_Array(Ergebnis)
				else
					Ergebnis = "unbekannt"
				end if
				end if
			case 6										'Belichtungsprogramm codiert
				if IsNumeric(Ergebnis) then
				if Ergebnis < 9 then
					Ergebnis = Belichtungsprogramm_Array(Ergebnis)
				else
					Ergebnis = "unbekannt"
				end if
				end if
			case 9										'Bildlage codiert
				if IsNumeric(Ergebnis) then
'				if Ergebnis = 1 then 	
'					Ergebnis = "quer (1)"
'				elseif Ergebnis = 6 Then	
'					Ergebnis = "hoch (6)"
'				end If

				select case Ergebnis
					case 1
						Ergebnis = "quer"
					case 3
						Ergebnis = "quer/ber Kopf"
					case 6
						Ergebnis = "hoch/nach links gekippt"
					case 8
						Ergebnis = "hoch/nach rechts gekippt"
					case else
						Ergebnis = "unbekannt"
				end select
				
				end if
			case 12										'Blitz Flash bit-codiert
				if IsNumeric(Ergebnis) then
				if Ergebnis < 255 then
					if Ergebnis mod 2 = 0 then Ergebnis = "Nein" else Ergebnis = "Ja"
				else
					Ergebnis = "unbekannt"
				end if

'				if Len (Ergebnis) > 0 Then
'					Ergebnis = DezBin8(Ergebnis)
'					if Mid(Ergebnis,8,1) = "1"  then Ergebnis = "mit Blitz"
'					if Mid(Ergebnis,8,1) = "0"  then Ergebnis = "ohne Blitz"
'					if Mid(Ergebnis,4,2) = "01" then Ergebnis = Ergebnis & ", forciert ein"
'					if Mid(Ergebnis,4,2) = "10" then Ergebnis = Ergebnis & ", forciert aus"
'					if Mid(Ergebnis,4,2) = "11" then Ergebnis = Ergebnis & ", Auto"
'					if Mid(Ergebnis,2,1) = "1"  then Ergebnis = Ergebnis & ", rote Augen"
'				End If
				
				end if

			case 26										'Lichtquelle codiert
				if IsNumeric(Ergebnis) then
				if Ergebnis < 12 then
					Ergebnis = Lichtquelle_Array(Ergebnis)
				else
					Ergebnis = "unbekannt"
				end if
				end if
			case 34										'Weissabgleich codiert
				if IsNumeric(Ergebnis) then
				if Ergebnis < 2 then
					Ergebnis = Weissabgleich_Array(Ergebnis)
				else
					Ergebnis = "unbekannt"
				end if
				end if
			case 16,35,36								'Datum z.B. 2010:03:01
				if Ergebnis <> "" then
				Ergebnis = mid(Ergebnis,9,2) & "." & mid(Ergebnis,6,2) & "." & left(Ergebnis,4) & mid(Ergebnis,11)
				end if
			case 24,32,44,46,56,66						'mehrzeiliger Text wird mit Tabs versehen
				WerteArray = split(Ergebnis,vbNewLine)
				Ergebnis = ""
				for each WerteElement in WerteArray
					Ergebnis = Ergebnis & WerteElement & vbNewLine & vbTab
				next
				if Ergebnis <> "" then Ergebnis = left(Ergebnis,len(Ergebnis)-3)
			
			case 42
				if Len(Ergebnis) > 0 Then
					Ergebnis = Replace(Ergebnis, ".", ",")
				end if
			
			case 57										'Objektname (Sondercodierung Maeckler - Original:)
				PosE = instr(Ergebnis,"l: ")
				if PosE = 8 then Ergebnis = mid(Ergebnis,PosE+3)
			
			case 62										'Keywords - aus vbNewLine wird Komma
				WerteArray = split(Ergebnis,vbNewLine)
				Ergebnis = ""
				for each WerteElement in WerteArray
					Ergebnis = Ergebnis & WerteElement & ", "
				next
				if right(Ergebnis,2) = ", " then Ergebnis = left(Ergebnis,len(Ergebnis)-2)
			
			case else
		end select
		end if
		
		if bool_LWAno = 0 or Ergebnis <> "" then
			Anzeigetext = Anzeigetext & Vorspann & Ergebnis & vbNewLine
		end if
		BildErgebnis = BildErgebnis & Ergebnis & chr(161)	'### Excel

	end if
	
next


if ExcelT then	'### Excel
	EArrayE = split(BildErgebnis,chr(161))
	for e = 0 to ubound(EArrayE) - 1
		EArrayG(n,e) = EArrayE(e)	'n = Bildnummer
	next
end if

End Sub
'---------------------------------------------------------------------
Sub Datentext_Lesen
Dim Ini_Datei,Anfang,Ende,Zeile,Datentext,PosZ,PosK,AbschnittD,VorspannErgebnis,ZwischenErgebnis
Anfang = false : Ende = false

if Abschnitt = "### Standard ###" then Abschnitt = ""
Set Ini_Datei = objFS.OpenTextFile(ini_FileName & "ini", ForReading, False)

Do While Ini_Datei.AtEndOfStream <> True

	Zeile = Ini_Datei.ReadLine
	
	if Anfang and instr(Zeile,"###+++ Datenbezeichnungen Ende ") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then 
		Datentext = Datentext & Zeile & vbNewLine
		if ExcelT then	'### Excel
			PosZ = instr(Zeile,"=")
			if PosZ = 1 then
				VorspannErgebnis = VorspannErgebnis & ";"
			elseif PosZ > 0 then
				ZwischenErgebnis = trim(left(Zeile,PosZ-1))
				if right(ZwischenErgebnis,1) = chr(9) then ZwischenErgebnis = trim(left(Zeile,PosZ-2))
				VorspannErgebnis = VorspannErgebnis & ZwischenErgebnis & ";"
			end if
		end if
	end if
	
	if instr(Zeile,"###+++ Datenbezeichnungen Anfang ") > 0 then
		PosZ = instr(Zeile,"/")
		if PosZ > 0 then 
			PosK = instr(PosZ+1,Zeile,"(")
			if PosK > 0 then
				AbschnittD = trim(mid(Zeile,PosZ+1,PosK-PosZ-1))
			else
				AbschnittD = trim(mid(Zeile,PosZ+1))
			end if
		end if
		if Abschnitt = AbschnittD then Anfang = true
	end if
Loop

Ini_Datei.Close

if Datentext <> "" then 
	Datentext = left(Datentext,len(Datentext)-2)
else
	Datentext = " "
end if
Datentext_Array = split(Datentext,vbNewline)

if ExcelT then EArrayU = split(VorspannErgebnis,";")	'### Excel

End Sub
'---------------------------------------------------------------------
Sub Beschriftung
Dim LetztesZeichen

if Anzeigetext = "" or Anzeigetext = vbNewLine then exit sub

LetztesZeichen = mid(Anzeigetext,len(Anzeigetext)-2,1)

with word.Selection
	.TypeText Anzeigetext

	.TypeBackspace
	.TypeBackspace

	.TypeText LetztesZeichen
end with

End Sub
'------------------------------------------------------------------------
Function Bereinigung (ErgebnisText)
'string werden Leerzeilen und Zeilenumbrche am Ende entfernt

ErgebnisText = trim(ErgebnisText)

do
	if right(ErgebnisText,2) = vbCrLf then
		ErgebnisText = left(ErgebnisText,len(ErgebnisText)-2)
	else
		exit do
	end if
loop

Bereinigung = ErgebnisText

End Function
'------------------------------------------------------------------------
Function DezBin8(Dez)
'Umwandlung Dezimalzahl zu 8-BIT-Binr-String
Dim x
Dez = Abs(Dez)

Do
	If (Dez And 2 ^ x) Then
		DezBin8 = "1" & DezBin8
	Else
		DezBin8 = "0" & DezBin8
 	End If
	x = x + 1
Loop Until 2 ^ x > Dez

'auf 8 Zeichen auffllen
DezBin8 = String(8 - Len(DezBin8), "0") & DezBin8

End Function
'------------------------------------------------------------------------
Sub Abschnittbenennung
Dim Ini_Datei,Zeile,Abschnitt,PosZ,PosK

AbschnittListe = "/"
FF_SetControl "Bilddaten nach Word/Excel","iniAbschnitt",""

Set Ini_Datei = objFS.OpenTextFile(ini_FileName & "ini", ForReading, False)

Do While Ini_Datei.AtEndOfStream <> True

	Zeile = Ini_Datei.ReadLine
	
	if instr(Zeile,"###+++ Datenbezeichnungen Anfang ") > 0 then
		PosZ = instr(Zeile,"/")
		if PosZ > 0 then
			PosK = instr(PosZ+1,Zeile,"(")
			if PosK > 0 then
				Abschnitt = trim(mid(Zeile,PosZ+1,PosK-PosZ-1))
			else
				Abschnitt = trim(mid(Zeile,PosZ+1))
			end if
		end if
		if Abschnitt = "" then
			FF_SetControl "Bilddaten nach Word/Excel","iniAbschnitt","### Standard ###"
			AbschnittListe = "/### Standard ###/"
			exit do
		else
			FF_SetControl "Bilddaten nach Word/Excel","iniAbschnitt",Abschnitt
			AbschnittListe = AbschnittListe & Abschnitt & "/"
		end if
	end if
	
Loop

Ini_Datei.Close

End Sub
'------------------------------------------------------------------------
Sub EWspeichern (Index)
'Einstellwerte bei Index = "S" speichern, bei Index = "L" lschen
Dim Ini_Datei,Zeile,PosZ,PosK,PosKZ,AbschnittD,Dateiinhalt,msg,Einstellung,p_Wechsel

'Dim Einstellung,Array,i,

Dim AbWerte : AbWerte = false

Abschnitt = FF_GetControl ("Bilddaten nach Word/Excel","iniAbschnitt")			'Abschnitt ermitteln
Set Ini_Datei = objFS.OpenTextFile(ini_FileName & "ini", ForReading, False)

Do While Ini_Datei.AtEndOfStream <> True
	Zeile = Ini_Datei.ReadLine

	if instr(Zeile,"###+++ Datenbezeichnungen Anfang ") > 0 then
		PosZ = instr(Zeile,"/")
		
		if PosZ > 0 then 
			PosK = instr(PosZ+1,Zeile,"(")
			if PosK > 0 then
				AbschnittD = trim(mid(Zeile,PosZ+1,PosK-PosZ-1))
			else
				AbschnittD = trim(mid(Zeile,PosZ+1))
			end if
		end if

		if Abschnitt = AbschnittD then
			if PosK > 0 then
				Zeile = left(Zeile,PosK-1)
				if Right(Zeile,1) <> " " then Zeile = Zeile & " "
				AbWerte = true
				exit do
			else
				if Right(Zeile,1) <> " " then Zeile = Zeile & " "
				exit do
			end if
		else
			Dateiinhalt = Dateiinhalt & Zeile & vbNewLine
		end if
	else
		Dateiinhalt = Dateiinhalt & Zeile & vbNewLine
	end if
Loop

if Index = "S" then
	if AbWerte then
		msg = 	"Im Profil '" & Abschnitt & "'" & vbNewLine & "sind bereits Werte vorhanden." & vbNewLine & _
				"Sollen diese berschrieben werden?"
	else
		msg = 	"Im Profil '" & Abschnitt & "'" & vbNewLine & "sind bisher keine Werte abgelegt." & vbNewLine & _
				"Sollen jetzt Werte eingetragen werden?"
	end if
	Antwort = msgbox(msg,vbYesNo or vbQuestion,"Einstellwerte")
	if Antwort = vbNo then
		Ini_Datei.Close
		exit sub
	end if

	'Einstellungen eintragen
	call WerteAuslesen

	if bool_SWechsel = 0 then
		p_Wechsel = 0
	else
		p_Wechsel = p_SWechsel
	end if

	Einstellung =	"(" & p_Schrift & "," & p_SGroesse & "," & AnzBilder & "," & _
					p_TabMM & "," & p_Wechsel & "," & bool_LWAno & ")"

	Dateiinhalt = Dateiinhalt & Zeile & Einstellung & vbNewLine

elseif Index = "L" then
	if AbWerte then
		msg = 	"Sollen im Profil '" & Abschnitt & "'" & vbNewLine & _
				"die vorhandenen Werte gelscht werden?"
		Antwort = msgbox(msg,vbYesNo or vbQuestion,"Einstellwerte")
		if Antwort = vbNo then
			Ini_Datei.Close
			exit sub
		end if
		Dateiinhalt = Dateiinhalt & Zeile & vbNewLine
	else
		msgbox "Im Profil '" & Abschnitt & "'" & vbNewLine & "sind keine Werte vorhanden.",vbInformation,"Einstellwerte"
		Ini_Datei.Close
		exit sub	
	end if
end if

'Rest der Ini-Datei auslesen
Do While Ini_Datei.AtEndOfStream <> True
	Zeile = Ini_Datei.ReadLine
	Dateiinhalt = Dateiinhalt & Zeile & vbNewLine
Loop

Ini_Datei.Close
Dateiinhalt = left(Dateiinhalt,len(Dateiinhalt)-2)

'Alles in die Ini-Datei schreiben
Set Ini_Datei = objFS.OpenTextFile(ini_FileName & "ini", ForWriting, False)
Ini_Datei.Write Dateiinhalt
Ini_Datei.Close

'BackUp?
Antwort = msgbox("Soll ein neues Backup angelegt werden?",vbQuestion or vbYesNo,"Backup")
if Antwort = vbYes then objFS.CopyFile ini_FileName & "ini",ini_FileName & "bak" ,true

End Sub
'------------------------------------------------------------------------
Sub Mapping
Dim Escape
Codepage = ""

Escape = FF_GetIPTC("Characterset")             ' Codepage auslesen
if Len(Escape) <> 0 then                        ' es stehen Codepage-Informationen zur Verfgung
    Escape = Right(Escape, 2)                   ' Escape-Zeichen abschneiden
    Select Case Escape
        Case HxAnsi(25) & HxAnsi(73)            ' MacRoman
            Codepage = 10000
        Case HxAnsi(25) & HxAnsi(47)            ' UTF-8
            Codepage = 65001
        Case HxAnsi(28) & HxAnsi(42)            ' US-ASCII
            Codepage = 20127
        Case HxAnsi("2C") & HxAnsi(41)          ' ISO-8859-1
            Codepage = 28591
        Case HxAnsi("2D") & HxAnsi(41)
            Codepage = 28591
        Case HxAnsi("2E") & HxAnsi(41)
            Codepage = 28591
        Case HxAnsi("2F") & HxAnsi(41)
            Codepage = 28591
        Case HxAnsi("2C") & HxAnsi(62)          ' ISO-8859-15
            Codepage = 28605
        Case HxAnsi("2D") & HxAnsi(62)
            Codepage = 28605
        Case HxAnsi("2E") & HxAnsi(62)
            Codepage = 28605
        Case HxAnsi("2F") & HxAnsi(62)
            Codepage = 28605
    End Select
end if

if len(Codepage) = 0 then Codepage = 28605

End sub
'-----------------------------------------------------------------------
Function HxAnsi (strHex)
' ** wandelt Hez-Zahl in das korrespondiernede ANSI-Zeichen
    HxAnsi = Chr(CLng("&H" & strHex))
End Function
'-----------------------------------------------------------------------
Sub ExcelTabelle
Dim i,Blatt,Anzahl
Dim Zeile,HoeheThumb,BreiteThumb
Dim rngZielZelle

'Excel-Optionen:
'Erweitert/Anzeige/Linealeinheiten = Standardeinheiten
'Breite = 4,8675 / cm  | ermittelt mit Excel 2016
'Hhe   = 28,3125 / cm | und Schrift Calibri 11
const ZB = 5	'Zellbreite fr Bildansicht in cm 
const ZH = 5	'Zellhhe fr Bildansicht in cm

'Excel-Aufruf
With excel
	.Workbooks.Add	'Tabellenblatt hinzufgen
	.Sheets("Tabelle1").Name = "Bilddaten"

	.Cells.Select
    With .Selection
    	.NumberFormat = "@"
        .HorizontalAlignment = 1
        .VerticalAlignment = -4160
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = -5002
        .MergeCells = False
    End With

    if Thumbnail and not Bildanz then
		.ActiveSheet.Cells(1,2).Resize(2,ubound(EArrayU)+1).Value = EArrayU
		.ActiveSheet.Cells(2,2).Resize(ubound(EArrayG,1)+1,ubound(EArrayG,2)+1).Value = EArrayG

		Zeile = 2
		for n = 0 to img
			if instr(Bildfilter,"." & ucase(objFS.GetExtensionName(Array(n))) & ".") > 0 then
				FF_LoadThumb Array(n)
				FF_YSharp 20
				FF_Sharp 20,true,true,true
				FF_KillExif : FF_KillIPTC
				FF_SaveImage TempBild,75
		
				HoeheThumb  = FF_GetImageFileHeight(TempBild)
				BreiteThumb = FF_GetImageFileWidth(TempBild)
			
				.Range("A" & cstr(Zeile)).Select
				.ActiveCell.Value = "_"
				.ActiveCell.AddComment							'Kommentarfeld hinzufgen
				.ActiveCell.Comment.Text " "					'Kommentartext lschen
				.ActiveCell.Comment.Shape.Fill.UserPicture TempBild	'Bild in Kommentarfeld einfgen
				.ActiveCell.Comment.Shape.Height = HoeheThumb	'Hhe des Kommentarfeldes
				.ActiveCell.Comment.Shape.Width = BreiteThumb	'Breite des Kommentarfeldes
			end if
			Zeile = Zeile + 1
			FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",(n+1)/(img+1)*100
		next
	elseif Bildanz then
		.ActiveSheet.Cells(1,2).Resize(2,ubound(EArrayU)+1).Value = EArrayU
		.ActiveSheet.Cells(2,2).Resize(ubound(EArrayG,1)+1,ubound(EArrayG,2)+1).Value = EArrayG
		
		.Columns("A").ColumnWidth = ZB * 4.8675	'Breite der Spalte A festlegen
		.Columns("A:A").Select
		.Selection.VerticalAlignment = -4160
		Zeile = 2
		for n = 0 to img
			if instr(Bildfilter,"." & ucase(objFS.GetExtensionName(Array(n))) & ".") > 0 then
				.Range("A" & cstr(Zeile)).Value = "x"
				.Range("A" & cstr(Zeile)).Select
				.Selection.RowHeight = ZH * 28.3125				'Hhe der Zeile festlegen
				Set rngZielZelle = .ActiveSheet.Cells(Zeile, 1)	'Zielzelle: Zeile, Spalte
				
				With .ActiveSheet.Pictures.Insert(Array(n))
        			.Top = rngZielZelle.Top
        			.Left = rngZielZelle.Left
						With .ShapeRange
							.LockAspectRatio = -1
							If .Height > rngZielZelle.Height Then .Height = rngZielZelle.Height
							If .Width > rngZielZelle.Width Then .Width = rngZielZelle.Width
						End With
				End With
			end if
			Zeile = Zeile + 1
			FF_SetControl "Bilddaten nach Word/Excel","Fortschritt",(n+1)/(img+1)*100
		next
	else
		.ActiveSheet.Cells(1,1).Resize(2,ubound(EArrayU)+1).Value = EArrayU
		.ActiveSheet.Cells(2,1).Resize(ubound(EArrayG,1)+1,ubound(EArrayG,2)+1).Value = EArrayG
	end if
	
	'Excel beenden
	.Rows("1:1").Select
	.Selection.Font.Bold = True
	if Bildanz then
		.Columns("B:Z").Select
	else 
		.Cells.Select
	end if
	.Selection.Columns.AutoFit	'Spaltenbreite optimieren
'	.Selection.Rows.AutoFit		'Zeilenhhe optimieren (nicht bei Bildanzeige)
	.Range("A1").Select	'Cursor an den Anfang stellen
	.visible = true		'Tabelle sichtbar machen
	
	'alle anderen Tabellenbltter lschen
	Anzahl = .sheets.count
	for i=1 to Anzahl -1
	    .Sheets(2).Select
	    .ActiveWindow.SelectedSheets.Delete
	next

end with

Set excel = Nothing		'Excelobjekt frei geben

End Sub
'-----------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
